import 'package:doctor_app_flutter/core/enum/filter_type.dart';
import 'package:doctor_app_flutter/core/viewModel/labs_view_model.dart';
import 'package:doctor_app_flutter/core/viewModel/project_view_model.dart';
import 'package:doctor_app_flutter/models/patient/patiant_info_model.dart';
import 'package:doctor_app_flutter/screens/base/base_view.dart';
import 'package:doctor_app_flutter/screens/patients/profile/lab_result/laboratory_result_page.dart';
import 'package:doctor_app_flutter/util/translations_delegate_base.dart';
import 'package:doctor_app_flutter/widgets/shared/app_expandable_notifier_new.dart';
import 'package:doctor_app_flutter/widgets/shared/app_scaffold_widget.dart';
import 'package:doctor_app_flutter/widgets/shared/doctor_card.dart';
import 'package:doctor_app_flutter/widgets/transitions/fade_page.dart';
import 'package:doctor_app_flutter/util/date-utils.dart';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

class LabsHomePage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    final routeArgs = ModalRoute.of(context).settings.arguments as Map;
    PatiantInformtion patient = routeArgs['patient'];
    ProjectViewModel projectViewModel = Provider.of(context);
    return BaseView<LabsViewModel>(
      onModelReady: (model) => model.getLabs(patient),
      builder: (context, LabsViewModel model, widget) => AppScaffold(
        baseViewModel: model,
        isShowAppBar: true,
        appBarTitle: TranslationBase.of(context).labOrders,
        body: SingleChildScrollView(
          physics: BouncingScrollPhysics(),
          child: FractionallySizedBox(
            widthFactor: 1.0,
            child: Center(
              child: Column(
                children: <Widget>[
                  Row(
                    children: <Widget>[
                      Expanded(
                        flex: 1,
                        child: InkWell(
                          onTap: () => model.setFilterType(FilterType.Clinic),
                          child: ListTile(
                            title: Text(TranslationBase.of(context).clinic),
                            leading: Radio(
                              value: FilterType.Clinic,
                              groupValue: model.filterType,
                              onChanged: (FilterType value) {
                                model.setFilterType(value);
                              },
                            ),
                          ),
                        ),
                      ),
                      Expanded(
                        flex: 1,
                        child: InkWell(
                          onTap: () => model.setFilterType(FilterType.Hospital),
                          child: ListTile(
                            title: Text(TranslationBase.of(context).hospital),
                            leading: Radio(
                              value: FilterType.Hospital,
                              groupValue: model.filterType,
                              onChanged: (FilterType value) =>
                                  model.setFilterType(value),
                            ),
                          ),
                        ),
                      )
                    ],
                  ),
                  ...List.generate(
                    model.patientLabOrdersList.length,
                    (index) => AppExpandableNotifier(
                      title: model.patientLabOrdersList[index].filterName,
                      bodyWidget: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: model
                            .patientLabOrdersList[index].patientLabOrdersList
                            .map((labOrder) {
                          return DoctorCard(
                            onTap: () => Navigator.push(
                              context,
                              FadePage(
                                page: LaboratoryResultPage(
                                  patientLabOrders: labOrder,
                                  patient: patient,
                                ),
                              ),
                            ),
                            isInOutPatient: labOrder.isInOutPatient,
                            name: labOrder.doctorName,
                            billNo: ' ${labOrder.invoiceNo}',
                            profileUrl: labOrder.doctorImageURL,
                            subName: labOrder.projectName,
                            isLiveCareAppointment:
                                labOrder.isLiveCareAppointment,
                            date: projectViewModel.isArabic
                                ? DateUtils.getMonthDayYearDateFormattedAr(
                                    labOrder.orderDate)
                                : DateUtils.getMonthDayYearDateFormatted(
                                    labOrder.orderDate),
                          );
                        }).toList(),
                      ),
                    ),
                  )
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }
}
